; Test program for pattern loading
; SNES version
; /Mic, 2009

.include "header.asm"
.include "Snes_Init.asm"
.include "snes_ppu.inc"


VBlank:    ; Needed to satisfy interrupt definition in "header.inc"
    rti


.bank 0
.section "MainCode"

Start:
    ; Initialize the SNES.
    Snes_Init

    sep     #$30        	; Set the A register to 8-bit.
    
    lda     #BLANK_SCREEN  	; Force VBlank by turning off the screen.
    sta     REG_DISPCNT

    SetPalette palette,0,32
    LoadVRAM patterns,0,(patterns_end-patterns)
    LoadVRAM map,$4000,(map_end-map)
    
    ; Set display mode 2 (all BG layers use 16-color tiles)
    lda	    #2
    sta     REG_DISPMODE
    
    lda     #BG0_ENABLE
    sta     REG_BGCNT
    
    ; Set the pattern base address for BG0 to $0000
    stz     REG_CHRBASE_L
    
    ; Set the map base address for BG0 to $4000 and the map size to 32x32 tiles
    lda     #32
    sta     REG_BG0MAP
    
    lda     #$0F  		; End VBlank, setting brightness to 15 (100%).
    sta     REG_DISPCNT

    ; Loop forever.
Forever:
    jmp Forever


patterns:
 .incbin "parodius2.pat"
patterns_end:

palette:
 .incbin "parodius2.pal"
palette_end:

map:
 .incbin "parodius2.nam"
map_end:

.ends
